#include "ButtonFolder.h"

long int rotValueFolder=0, swValueFolder=0;
uint8_t stateFolder=0;

portMUX_TYPE gpioMuxFolder = portMUX_INITIALIZER_UNLOCKED;


void IRAM_ATTR isrABFolder() {
   uint8_t s = stateFolder & 3;

  portENTER_CRITICAL_ISR(&gpioMuxFolder);
    if (digitalRead(PIN_FOLDER_DT)) s |= 4;
    if (digitalRead(PIN_FOLDER_CLK)) s |= 8;
    switch (s) {
      case 0: case 5: case 10: case 15:
        break;
      case 1: case 7: case 8: case 14:
        rotValueFolder++; break;
      case 2: case 4: case 11: case 13:
        rotValueFolder--; break;
      case 3: case 12:
        rotValueFolder += 2; break;
      default:
        rotValueFolder -= 2; break;
    }
    stateFolder = (s >> 2);
   portEXIT_CRITICAL_ISR(&gpioMuxFolder);

}


void IRAM_ATTR isrSWAllFolder() {

 portENTER_CRITICAL_ISR(&gpioMuxFolder);
 swValueFolder++;
 portEXIT_CRITICAL_ISR(&gpioMuxFolder);

}


void ButtonFolder_init() {
  //
  // Set up IO pins and interrupts
  //

  pinMode(PIN_FOLDER_DT, INPUT_PULLUP);
  pinMode(PIN_FOLDER_CLK, INPUT_PULLUP);
  pinMode(PIN_FOLDER_SW, INPUT_PULLUP);

  attachInterrupt(digitalPinToInterrupt(PIN_FOLDER_DT), isrABFolder, CHANGE);
  attachInterrupt(digitalPinToInterrupt(PIN_FOLDER_CLK), isrABFolder, CHANGE);
  attachInterrupt(digitalPinToInterrupt(PIN_FOLDER_SW), isrSWAllFolder, RISING);
}

boolean ButtonFolder_IsPushed() {
  //
  // returns true is the rotary switch has been pushed on
  //
  if (swValueFolder != 0) {
    portENTER_CRITICAL_ISR(&gpioMuxFolder);
    swValueFolder = 0;
    portEXIT_CRITICAL_ISR(&gpioMuxFolder);
    return true;
  }
  else
    return false; 
}

int ButtonFolder_getTurnedNb() {
  //
  // Returns the number of ticks (when rotary switch is turned) with the sign (+ clockwise, - anticlockwise)
  //
  int value = rotValueFolder;
  if (abs(rotValueFolder) >= 4) {
    portENTER_CRITICAL_ISR(&gpioMuxFolder);
    rotValueFolder=0;
    portEXIT_CRITICAL_ISR(&gpioMuxFolder);
    return value/4;
  } else
    return 0;
}
